package com.pdaaphm.biz.mapper;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.pdaaphm.biz.domain.Algorithm;
import org.apache.ibatis.annotations.Param;

/**
 * 算法Mapper接口
 *
 * @author xlk
 * @date 2023-08-16
 */
public interface AlgorithmMapper
{
    /**
     * 查询算法
     *
     * @param id 算法主键
     * @return 算法
     */
    public Algorithm selectAlgorithmById(Long id);

    /**
     * 查询算法列表
     *
     * @param algorithm 算法
     * @return 算法集合
     */
    public List<Algorithm> selectAlgorithmList(Algorithm algorithm);

    /**
     * 新增算法
     *
     * @param algorithm 算法
     * @return 结果
     */
    public int insertAlgorithm(Algorithm algorithm);

    /**
     * 修改算法
     *
     * @param algorithm 算法
     * @return 结果
     */
    public int updateAlgorithm(Algorithm algorithm);

    /**
     * 删除算法
     *
     * @param id 算法主键
     * @return 结果
     */
    public int deleteAlgorithmById(Long id);

    /**
     * 批量删除算法
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAlgorithmByIds(Long[] ids);

    public List<Map> getOption();

    public List<Map> selectUrlAndAddressById(Long id);

    public void updateStartTimeById(@Param("id") Long id, @Param("startTime") Date startTime);

    public void updateCompletedTimeById(@Param("id") Long id, @Param("completedTime") Date completedTime);

    public void updateCostSecondById(@Param("id") Long id, @Param("costSecond") Long costSecond);

    public void updateStatusById(@Param("id") Long id, @Param("statusCode") String statusCode);

    public int  deleteAlgorithmBySubTypeId(Long id);
}
